`timescale 1ns / 1ps

`include "model_1645RT2.v"

module test_1645RT2;		



reg nPE, nOE, nCE;
reg [14:0] A;
reg [7:0] D_IN; 
reg  T1, T2;	 



wire [7:0] D; 
wire Dout_nEN;
assign Dout_nEN=~nCE & nPE & ~nOE;
assign D = (Dout_nEN)? 'bz : D_IN;


//-=-=-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-





model_1645RT2 model_1645RT2_(
A, D, nCE, nPE, nOE, T1, T2  
); 


initial
begin  
	
T1<=1'b1;
T2<=1'b0;

nPE<=1'b1;
nOE<=1'b1;
nCE<=1'b1;
	
A<='b0;
D_IN<='b0;


#1_000_000;
CE_READ(15'h01);
ADR_READ(15'h06);
CE_READ(15'h0A);
ADR_READ(15'h0A);
CE_READ(15'h00);
CE_READ(15'h6B);
CE_READ(15'h03);
PE_PROGRAM(15'h0A,8'b0000_0100);
PE_PROGRAM(15'h6B,8'b1000_0000);
CE_READ(15'h01);
ADR_READ(15'h06);
CE_READ(15'h0A);
ADR_READ(15'h0A);
CE_READ(15'h00);
ADR_READ(15'h03);
CE_READ(15'h6B);
#1_000_000; 
$stop;
end



initial
begin
#100000000;
//$stop;
end




task CE_READ;
input [14:0] adress;  
begin 
#100;
A<=adress;
#100;
nCE<=1'b0;
nOE<=1'b0;
#200; 
nCE<=1'b1;
nOE<=1'b1;
#100;
end
endtask	 

task ADR_READ;
input [14:0] adress;  
begin 
#100;
A<=adress;
#100;
nCE<=1'b0;
nOE<=1'b0;
#200; 
end
endtask	

task PE_PROGRAM;
input [14:0] adress;   
input [7:0] data;
begin
#1000;
A<=adress;
#1000;
nCE<=1'b0; 
#100_000;
nPE<=1'b0; 
#300_000;

D_IN<=data;
#1_700_000; 
D_IN<=8'h00;
#1000; 
nPE<=1'b1; 
#100_000;
nCE<=1'b1;
#100_000;


end
endtask	 



endmodule
